// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ZylNMEAGenerator.pas' rev: 6.00

#ifndef ZylNMEAGeneratorHPP
#define ZylNMEAGeneratorHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Registry.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Zylnmeagenerator
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TCardinalPoint { cpNorth, cpSouth, cpEast, cpWest };
#pragma option pop

#pragma option push -b-
enum ZylNMEAGenerator__1 { GPGLL, GPGGA, GPVTG, GPRMC, GPGSA, GPGSV, GPZDA };
#pragma option pop

typedef Set<ZylNMEAGenerator__1, GPGLL, GPZDA>  TNMEACommands;

class DELPHICLASS TZylNMEAGenerator;
class PASCALIMPLEMENTATION TZylNMEAGenerator : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FRegistered;
	int FLatDeg;
	int FLatMin;
	Extended FLatSec;
	TCardinalPoint FLatDir;
	TCardinalPoint FLongDir;
	int FLongDeg;
	int FLongMin;
	Extended FLongSec;
	Extended FSpeed;
	Extended FHeading;
	Extended FAltitude;
	Extended FMagnetic_Variation;
	Extended FMagnetic_Heading;
	TCardinalPoint FDeclination;
	Extended FPDOP;
	Extended FHDOP;
	Extended FVDOP;
	Extended FGeo_Height;
	System::TDateTime FUTCDateTime;
	TNMEACommands FCommands;
	bool FUseSystemDateTime;
	bool FMessageAlert;
	double FVersion;
	bool __fastcall RunningInTheIDE(void);
	
protected:
	AnsiString FCommPort;
	unsigned ComDevice;
	AnsiString __fastcall ReplaceDecimalSeparatorEx(AnsiString s, AnsiString DS);
	AnsiString __fastcall GetNMEACheckSum(AnsiString str);
	AnsiString __fastcall MaxLenStr(AnsiString s, int MaxLen, char c);
	AnsiString __fastcall MaxLenStrInv(AnsiString s, int MaxLen, char c);
	void __fastcall SetLatDeg(int Value);
	void __fastcall SetLatMin(int Value);
	void __fastcall SetLatSec(Extended Value);
	void __fastcall SetLongDeg(int Value);
	void __fastcall SetLongMin(int Value);
	void __fastcall SetLongSec(Extended Value);
	void __fastcall SetHeading(Extended Value);
	AnsiString __fastcall GetUTCDateStr();
	AnsiString __fastcall GetUTCDateLongStr();
	AnsiString __fastcall GetUTCTimeStr();
	System::TDateTime __fastcall GetUTCDateTime(void);
	System::TDateTime __fastcall GetLocalDateTime(void);
	AnsiString __fastcall GetLatitudeStr();
	AnsiString __fastcall GetLongitudeStr();
	AnsiString __fastcall GetDeclinationStr();
	
public:
	__property double Version = {read=FVersion};
	__fastcall virtual TZylNMEAGenerator(Classes::TComponent* AOwner);
	__fastcall virtual ~TZylNMEAGenerator(void);
	AnsiString __fastcall GetNMEA();
	AnsiString __fastcall GetGPZDA();
	AnsiString __fastcall GetGPGGA();
	AnsiString __fastcall GetGPGLL();
	AnsiString __fastcall GetGPGSA();
	AnsiString __fastcall GetGPRMC();
	AnsiString __fastcall GetGPVTG();
	Extended __fastcall GetLatitudeAsDecimalDegrees(void);
	Extended __fastcall GetLongitudeAsDecimalDegrees(void);
	Extended __fastcall KmhToKnots(Extended pSpeed);
	Extended __fastcall KnotsToKmh(Extended pSpeed);
	Extended __fastcall KmToMiles(Extended pDist);
	Extended __fastcall MilesToKm(Extended pDist);
	Extended __fastcall DMSToDecimalDegrees(int Degree, int Minute, Extended Second, TCardinalPoint Direction);
	void __fastcall LatitudeDecimalDegreesToDMS(Extended DecDegree, int &Degree, int &Minute, Extended &Second, TCardinalPoint &Direction);
	void __fastcall LongitudeDecimalDegreesToDMS(Extended DecDegree, int &Degree, int &Minute, Extended &Second, TCardinalPoint &Direction);
	bool __fastcall Connect(AnsiString SerialPortName);
	void __fastcall Disconnect(void);
	void __fastcall Transmit(void);
	AnsiString __fastcall GetSerialPort();
	void __fastcall AddSecondsToLatitude(double seconds);
	void __fastcall AddSecondsToLongitude(double seconds);
	
__published:
	__property int Latitude_Degree = {read=FLatDeg, write=SetLatDeg, nodefault};
	__property int Latitude_Minute = {read=FLatMin, write=SetLatMin, nodefault};
	__property Extended Latitude_Second = {read=FLatSec, write=SetLatSec};
	__property TCardinalPoint Latitude_Direction = {read=FLatDir, write=FLatDir, nodefault};
	__property int Longitude_Degree = {read=FLongDeg, write=SetLongDeg, nodefault};
	__property int Longitude_Minute = {read=FLongMin, write=SetLongMin, nodefault};
	__property Extended Longitude_Second = {read=FLongSec, write=SetLongSec};
	__property TCardinalPoint Longitude_Direction = {read=FLongDir, write=FLongDir, nodefault};
	__property Extended Altitude = {read=FAltitude, write=FAltitude};
	__property Extended Heading = {read=FHeading, write=SetHeading};
	__property Extended Speed = {read=FSpeed, write=FSpeed};
	__property TCardinalPoint Declination = {read=FDeclination, write=FDeclination, nodefault};
	__property Extended PDOP = {read=FPDOP, write=FPDOP};
	__property Extended HDOP = {read=FHDOP, write=FHDOP};
	__property Extended VDOP = {read=FVDOP, write=FVDOP};
	__property Extended Geo_Height = {read=FGeo_Height, write=FGeo_Height};
	__property Extended Magnetic_Variation = {read=FMagnetic_Variation, write=FMagnetic_Variation};
	__property Extended Magnetic_Heading = {read=FMagnetic_Heading, write=FMagnetic_Heading};
	__property System::TDateTime UTCDateTime = {read=FUTCDateTime, write=FUTCDateTime};
	__property TNMEACommands Commands = {read=FCommands, write=FCommands, nodefault};
	__property bool UseSystemDateTime = {read=FUseSystemDateTime, write=FUseSystemDateTime, default=1};
	__property bool MessageAlert = {read=FMessageAlert, write=FMessageAlert, default=1};
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace Zylnmeagenerator */
using namespace Zylnmeagenerator;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// ZylNMEAGenerator
